<?php
$set['script']     = $_SERVER['PHP_SELF'];
$set['Title']      = "I miei film";
$set['FirstField'] = "onload='document.filmForm.movie_title.focus()'";
$set['log']        = false;

if($set['log']) error_log("script      : ***** ".$set['script'], 0);
if($set['log']) error_log("bottone     : ".(empty($_POST['submit']) ? '' : $_POST['submit']), 0);

require_once 'archivioFilm.include';

/* ---------------------------------------------------------------- */

$message = "";

if ( empty($_POST) or $_POST['submit'] == "rinuncia" )
{
    inizializzaVariabili();    // lo script é allo stato iniziale o al termine di una azione
}
else
{
    leggiPost();               // lo script é chiamato dopo un submit

    validaForm();

    if  ( empty($message)
    and   in_array( $set['azione'], 
                    array("cerca", "conferma ins", "conferma mod", "conferma elim") ) )
    {
        aggiornaDB($set['azione']);
    }
}
displayForm($set['azione']);
die;

/* ---------------------------------------------------------------- */

function inizializzaVariabili()
{
    global $conn, $set, $row;

    if($set['log']) error_log("inizializzaVariabili", 0);

    $set['azione']       = "";

    $row['film_id']      = "";
    $row['movie_title']  = "";
    $row['also_known']   = "";
    $row['year']         = "";
    $row['minutes']      = "";
    $row['distributor']  = "";
    $row['studio']       = "";
    $row['release_data'] = "";
    $row['incollection'] = "0";
    $row['synopsis']     = "";
}

/* ---------------------------------------------------------------- */

function leggiPost()
{
    global $conn, $set, $row;

    $set['azione']       = trim(htmlspecialchars($_POST['submit']));

    if($set['log']) error_log("leggiPost   : ".$set['azione'], 0);

    $row['film_id']      = trim(htmlspecialchars($_POST['film_id']));
    $row['movie_title']  = trim(htmlspecialchars($_POST['movie_title']));
    $row['also_known']   = trim(htmlspecialchars($_POST['also_known']));
    $row['year']         = trim(htmlspecialchars($_POST['year']));
    $row['minutes']      = trim(htmlspecialchars($_POST['minutes']));
    $row['distributor']  = trim(htmlspecialchars($_POST['distributor']));
    $row['studio']       = trim(htmlspecialchars($_POST['studio']));
    $row['release_data'] = trim(htmlspecialchars($_POST['release_data']));
    $row['incollection'] = trim(htmlspecialchars($_POST['incollection']));
    $row['synopsis']     = trim(htmlspecialchars($_POST['synopsis']));
}

/* ---------------------------------------------------------------- */

function validaForm()
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("validaForm  : ".$set['azione'], 0);

    // qui vanno fatti i controlli dei dati inseriti

    if( !in_array( $set['azione'], 
                   array("inserisci", "cerca", "modifica", "elimina", "conferma ins", "conferma mod", "conferma elim") ) ) 
    {
        $message = "ERRORE : non riconosco l&acute;azione da compiere";
        return;
    }

    if( in_array( $set['azione'], 
                  array("cerca", "modifica", "elimina", "conferma mod", "conferma elim") ) )
    {
        if( empty($row['film_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : devi indicare il film ID";
            return;
        }
        if( empty(aggiornaDB("conta_id")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : non ho trovato nessun elemento con l&acute;ID indicato";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins") ) )
    {
        if( !empty($row['film_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : nella fase di inserimento l&acute;ID non deve essere presente";
            return;
        }
        if( !empty(aggiornaDB("conta_titolo")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : stai tentando di inserire un titolo che esiste gi&agrave";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins", "modifica", "conferma mod") ) )
    {
//      QUI DEVE ESSERE CONTROLLATA LA PRESENZA E CONGRUITA' DEI DATI
    }
}

/* ---------------------------------------------------------------- */

function aggiornaDB($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("aggiornaDB  : ".$azione, 0);

    switch ($azione)
    {
        case "conferma ins":
            $sql = "INSERT INTO film(movie_title, also_known, year, minutes, distributor, studio, release_data, incollection, synopsis) VALUES ("
                 . "  '" . $row['movie_title']  . "'"
                 . ", '" . $row['also_known']   . "'"
                 . ", '" . $row['year']         . "'"
                 . ", '" . $row['minutes']      . "'"
                 . ", '" . $row['distributor']  . "'"
                 . ", '" . $row['studio']       . "'"
                 . ", '" . $row['release_data'] . "'"
                 . ", '" . $row['incollection'] . "'"
                 . ", '" . $row['synopsis']     . "'"
                 . "  )";
            break;

        case "conferma mod":
            $sql = "UPDATE film SET"
                 . "  movie_title='"   . $row['movie_title']  . "'"
                 . ", also_known='"    . $row['also_known']   . "'"
                 . ", year='"          . $row['year']         . "'"
                 . ", minutes='"       . $row['minutes']      . "'"
                 . ", distributor='"   . $row['distributor']  . "'"
                 . ", studio='"        . $row['studio']       . "'"
                 . ", release_data='"  . $row['release_data'] . "'"
                 . ", incollection='"  . $row['incollection'] . "'"
                 . ", synopsis='"      . $row['synopsis']     . "'"
                 . "  WHERE film_id='" . $row['film_id']      . "'";
            break;

        case "conferma elim":
            $sql = "DELETE FROM film"
                 . " WHERE film_id='" . $row['film_id']. "'";
            break;

        case "cerca":
            $sql = "SELECT film_id, movie_title, also_known, year, minutes, distributor, studio, release_data, incollection, synopsis"
                 . " FROM film WHERE film_id='" . $row['film_id'] . "'";
            break;

        case "conta_id":
            $sql = "SELECT count(*) as counter FROM film WHERE film_id='" . $row['film_id'] . "'";
            break;

        case "conta_titolo":
            $sql = "SELECT count(*) as counter FROM film WHERE movie_title='" . $row['movie_title'] . "'";
            break;

        default:
            $message = "ERRORE : aggiornaDB, azione non riconosciuta";
            return;
            break;
    }
    if($set['log']) error_log("sql         : ".$sql, 0);



    $result = $conn->query($sql);
    if ( !$result ) { $message = "ERRORE : aggiornaDB, errore nella query, " . $conn->error; return; }

    if( in_array( $azione, 
                  array("cerca", "conta_id", "conta_titolo") ) ) 
    {
        $dati = $result->fetch_assoc();  $result->free();
    }



    switch ($azione)
    {
        case "cerca":
            $row = $dati;
            break;

        case "conta_id":
        case "conta_titolo":
            return $dati['counter'];
            break;

        default:
            inizializzaVariabili();
            $message = "Congratulazioni, il database é stato aggiornato.";
            break;
    }
}

/* ---------------------------------------------------------------- */

function displayForm($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("displayForm : ".$azione, 0);
    if($set['log']) error_log("errore      : ".$message, 0);

    // gestisci bottoni
    $readonly1 = " readonly";
    $readonly2 = " readonly";

    switch ($azione)
    {
        case "cerca":
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='modifica' />"
                 . "<input type='submit' name='submit' value='elimina' />";
            break;

        case "inserisci":
            $btn = "<input type='submit' name='submit' value='conferma ins' />";
            break;

        case "modifica":
            $btn = "<input type='submit' name='submit' value='conferma mod' />";
            break;

        case "elimina":
            $btn = "<input type='submit' name='submit' value='conferma elim' />";
            break;

        default:
            $readonly1 = "";
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='inserisci' />"
                 . "<input type='submit' name='submit' value='cerca' />";
            break;
    }
    $btn .= "<input type='submit' name='submit' value='rinuncia' />";


    // valorizza la select "incollection"
    $opt = "";
    $incollection = array( 0 => 'scegli uno stato', 1 => 'Yes', 2 => 'No' );  // possible options for career status
    for( $i=0; $i < count($incollection); $i++ )
    {
        $selected = $i == $row['incollection'] ? ' selected' : '';
        $opt .= "<option" . $selected . " value='" . $i . "'>" . $incollection[$i] . "</option>";
    }

?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <title><?= $set['Title']; ?></title>
  </head>
  <body <?= $set['FirstField']; ?>>

<div class='form-group'>

  <center><h1><span class='infoblock-pagetype'>Archivio dei film</span></h1></center>

  <form name='filmForm' method='POST' action='<?= $set['script']; ?>'>

    <table id='biographyTable' border='0' cellspacing='0' cellpadding='0' width='100%'>
      <tbody>
        <tr>
          <td class='paramname'>
            <b>film ID:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='film_id' id='film_id' size='10' value='<?= $row['film_id']; ?>'<?= $readonly1; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Title:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='movie_title' id='movie_title' size='100' value='<?= $row['movie_title']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Also Known As:</b>
          </td>
          <td class='paramvalue'>
            <textarea name='also_known' id='also_known' size='50'  style='width: 98%'<?= $readonly2; ?>><?= $row['also_known']; ?></textarea>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Year: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='year' id='year' size='10' value='<?= $row['year']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
        <tr>
          <td class='paramname'>
            <b>Minutes: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='minutes' id='minutes' size='10' value='<?= $row['minutes']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Distributor: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='distributor' id='distributor' size='100' value='<?= $row['distributor']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Studio: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='studio' id='studio' size='100' value='<?= $row['studio']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Release Date: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='release_data' id='release_data' size='15' value='<?= $row['release_data']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>In Collection: </b> (<b><font color='red'>selezionare il valore</font></b>)
          </td>
          <td class='paramvalue'>
            <select name='incollection', id='incollection'><?= $opt; ?></select>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Synopsis: </b>
          </td>
          <td class='paramvalue'>
            <textarea name='synopsis' id='editor1' rows='10' cols='80'<?= $readonly2; ?>><?= $row['synopsis']; ?></textarea>
          </td>
        </tr>
<!--
        <tr>
          <td class='paramname'>
            <b>Status:</b> (<b><font color='red'>Active, Retired, Dead</font></b>)
          </td>
          <td class='paramvalue'>
            <input type='text' name='status' id='status' value='<?php // echo $row['status']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
-->
        <tr>
          <td class='paramvalue-footer center' colspan='2'>
            <br />
            <?= $btn; ?>
            &nbsp;<br />
            &nbsp;<br />
          </td>
        </tr>
      </tbody>
    </table>
  </form>
  <div class='col-sm-10 col-sm-offset-2'><h2><?= $message; ?></h2></div>
</div>

<script src="https://cdn.ckeditor.com/ckeditor5/18.0.0/classic/ckeditor.js"></script>
<script> CKEDITOR.replace('editor1', { extraPlugins: 'colorbutton,colordialog' });</script>

</body>
</html>
<?php
}
?>
